// Author:       Andreas F. Borchert
// Description:  sinus function as extension of Function

#include <cmath>
#include <string>
#include <sstream>
#include <iostream>
#include "Cosinus.h"

std::string Cosinus::get_name() const {
   return "cos";
} // Cosinus::get_name()

std::string Cosinus::execute(std::string x) const {
   double cosWert, cosArg;
   std::string cosString;
   
   // in einen Stream verwandeln
   std::istringstream str(x);
   // Umwandlung String -> double
   str >> cosArg;
   // Cos ermitteln
   cosWert = std::cos(cosArg);
   
   // Umwandlung Cos-> String
   std::stringstream ssf;
   ssf << cosWert;
//   ssf << std::setprecision(3) << cosWert;
   ssf >> cosString;
   return cosString;

} // Cosinus::execute

extern "C" Function* construct() {
   return new Cosinus();
}

